// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.15.0
// source: authboss.sql

package database

import (
	"context"
)

const authInsert = `-- name: AuthInsert :exec
INSERT INTO users (id, email, name)
VALUES (?, ?, ?)
`

type AuthInsertParams struct {
	ID    string
	Email string
	Name  string
}

func (q *Queries) AuthInsert(ctx context.Context, arg AuthInsertParams) error {
	_, err := q.db.ExecContext(ctx, authInsert, arg.ID, arg.Email, arg.Name)
	return err
}

const authLoad = `-- name: AuthLoad :one
SELECT id, email, name, created_at, authorized_at, role FROM users
WHERE id = ?
`

func (q *Queries) AuthLoad(ctx context.Context, id string) (User, error) {
	row := q.db.QueryRowContext(ctx, authLoad, id)
	var i User
	err := row.Scan(
		&i.ID,
		&i.Email,
		&i.Name,
		&i.CreatedAt,
		&i.AuthorizedAt,
		&i.Role,
	)
	return i, err
}

const authSave = `-- name: AuthSave :exec
UPDATE users SET email = ?
WHERE id = ?
`

type AuthSaveParams struct {
	Email string
	ID    string
}

func (q *Queries) AuthSave(ctx context.Context, arg AuthSaveParams) error {
	_, err := q.db.ExecContext(ctx, authSave, arg.Email, arg.ID)
	return err
}
